import { Meta, Story, Props, Preview } from '@storybook/addon-docs/blocks';
import { PropsTable } from '@storybook/components';
// import {getResourcePreviewProps} from 'ui/mock/context'
import {ConfirmDeleteModal} from 'ui/modules/ConfirmDeleteModal'
import { User } from './User';
import { Resource } from './Resource';
import {Community} from './Community';
import {Collection} from './Collection';
import {Comment} from './Comment';
import {MainComment} from './MainComment';
import {LikedComment} from './LikedComment';
import {FlaggedItem} from './FlaggedItem';
import {Thread} from './Thread';
import {Box} from 'rebass'
import { useFormik } from 'formik';
const getActions = () => ({
  FlagModal: () => {
    const formik = useFormik<{ reason: '' }>({
      initialValues: {
        reason: ''
      },
      onSubmit: () => {
        action('submit')();
        return new Promise((resolve, reject) => {
          setTimeout(resolve, 3000);
        });
      }
    });
    const getFlagModalProps = {
      formik,
      flagId: '',
      cancel: action('cancel')
    };
    return <FlagModal {...getFlagModalProps} />;
  },
  like: {
    totalLikes: 3,
    toggleLikeFormik: useFormik<{}>({
      initialValues: {},
      onSubmit: vals => {
        action('submitting...')();
        return new Promise(resolve =>
          setTimeout(() => {
            action('submitted...')();
            resolve();
          }, 2000)
        );
      }
    }),
    iLikeIt: true
  },
  reply: {
    replyFormik: useFormik<{ replyMessage: String }>({
      initialValues: { replyMessage: '' },
      onSubmit: vals => {
        action(`submitting: ${vals.replyMessage}`)();
        return new Promise(resolve =>
          setTimeout(() => {
            action(`submitted: ${vals.replyMessage}`)();
            resolve();
          }, 2000)
        );
      }
    })
  }
});

<Meta title="Modules|Main Previews"/>

# User
Let's define a story for the `User preview` module

<Preview>
  <Story name="User preview module">
     <Box
        sx={{
          borderRadius: '6px',
          background: '#fff',
          width: '600px',
          margin: '0 auto'
        }}
        p={2}
      >
    <User 
      image={"https://pbs.twimg.com/profile_images/1161428802091802627/O49Ggs-7_400x400.jpg"}
      name={"˗ˏˋ Doug Belshaw ˎˊ˗ 🇪🇺 ☠️ ✊" }
      username={"dajbelshaw@team.moodle.net"}
      bio={"Open Educational Thinkerer. Product Manager @MoodleNet & Co-op founder @WeAreOpenCoop. Aspiring Mountain Leader. Previously: @Mozilla @Jisc teacher"}
      isFollowing={true}
       toggleFollowFormik = {useFormik<{}>({
          initialValues: {},
          onSubmit: vals => {
            action('submitting...')();
            return new Promise(resolve =>
              setTimeout(() => {
                action('submitted...')();
                resolve();
              }, 2000)
            );
          }
        })}
    />
    </Box>
  </Story>
</Preview>


# Resource via URL
Let's define a story for the `Resource via url preview` module

<Preview>
  <Story name="Resource via url preview module">
     <Box
        sx={{
          borderRadius: '6px',
          background: '#fff',
          width: '600px',
          margin: '0 auto'
        }}
        p={2}
      >
    <Resource
        like={{
    totalLikes: 3,
    toggleLikeFormik: useFormik<{}>({
      initialValues: {},
      onSubmit: vals => {
        action('submitting...')();
        return new Promise(resolve =>
          setTimeout(() => {
            action('submitted...')();
            resolve();
          }, 2000)
        );
      }
    }),
    iLikeIt: true
  }}
        id={"1"}
        icon={"https://files.mastodon.social/accounts/headers/001/105/637/original/6da7b224d62ebeb5.png"}
        name={"mantarai"}
        summary={"After longtime I made a design for Uplabs Music player design challenge. i hope you all like this. if you like my design dont forgot to Vote in Uplabs ( 25 June ). Vote Here "}
        link={"https://www.pinterest.it/topics/anime/"}
        isLocal={false}
        type={'image'}
        license={null}
    />
    </Box>
  </Story>
</Preview>

# Uploaded Resource
Let's define a story for the `Uploaded Resource preview` module
<Preview>
  <Story name="Uploaded Resource preview module">
     <Box
        sx={{
          borderRadius: '6px',
          background: '#fff',
          width: '600px',
          margin: '0 auto'
        }}
        p={2}
      >
    <Resource
      like={{
    totalLikes: 3,
    toggleLikeFormik: useFormik<{}>({
      initialValues: {},
      onSubmit: vals => {
        action('submitting...')();
        return new Promise(resolve =>
          setTimeout(() => {
            action('submitted...')();
            resolve();
          }, 2000)
        );
      }
    }),
    iLikeIt: true
  }}
        id={"1"}
        icon={"https://files.mastodon.social/accounts/headers/001/105/637/original/6da7b224d62ebeb5.png"}
        name={"mantarai"}
        summary={"After longtime I made a design for Uplabs Music player design challenge. i hope you all like this. if you like my design dont forgot to Vote in Uplabs ( 25 June ). Vote Here "}
        link={"anime.pdf"}
        license={"CC-BY-4.0"}
        acceptedLicenses= {["CC0-1.0", "CC-BY-4.0", "CC-BY-SA-4.0"]}
        isLocal={true}
        type={'pdf'}
    />
    </Box>
  </Story>
</Preview>

# Community
Let's define a story for the `Community preview` module

<Preview>
  <Story name="Community preview module">
     <Box
        sx={{
          borderRadius: '6px',
          background: '#fff',
          width: '600px',
          margin: '0 auto'
        }}
        p={2}
      >
    <Community
        id={"1"}
        icon={"https://files.mastodon.social/accounts/headers/001/105/637/original/6da7b224d62ebeb5.png"}
        name={"mantarai"}
        summary={"After longtime I made a design for Uplabs Music player design challenge. i hope you all like this. if you like my design dont forgot to Vote in Uplabs ( 25 June ). Vote Here "}
        followersCount={12}
        collectionsCount={6}
        followed={true}
        threadsCount={3}
        link={{url: "/", external: true}}
        toggleJoinFormik = {useFormik<{}>({
          initialValues: {},
          onSubmit: vals => {
            action('submitting...')();
            return new Promise(resolve =>
              setTimeout(() => {
                action('submitted...')();
                resolve();
              }, 2000)
            );
          }
        })}
    />
    </Box>
  </Story>
</Preview>

# Collection
Let's define a story for the `Collection preview` module

<Preview>
  <Story name="Collection preview module">
     <Box
        sx={{
          borderRadius: '6px',
          background: '#fff',
          width: '600px',
          margin: '0 auto'
        }}
        p={2}
      >
    <Collection
        link={{url: "/", external: true}}
        id={"1"}
        icon={"https://files.mastodon.social/accounts/headers/001/105/637/original/6da7b224d62ebeb5.png"}
        name={"mantarai"}
        summary={"After longtime I made a design for Uplabs Music player design challenge. i hope you all like this. if you like my design dont forgot to Vote in Uplabs ( 25 June ). Vote Here "}
        totalResources={12}
        toggleFollowFormik = {useFormik<{}>({
          initialValues: {},
          onSubmit: vals => {
            action('submitting...')();
            return new Promise(resolve =>
              setTimeout(() => {
                action('submitted...')();
                resolve();
              }, 2000)
            );
          }
        })}
    />
    </Box>
  </Story>
</Preview>

# Comment
Let's define a story for the `Comment preview` module

<Preview>
  <Story name="Comment preview module">
     <Box
        sx={{
          borderRadius: '6px',
          background: '#fff',
          width: '600px',
          margin: '0 auto'
        }}
        p={2}
      >
    <Comment
        {...getActions()}
        url={"/"}
        content={"After longtime I made a design for Uplabs Music player design challenge. i hope you all like this. if you like my design dont forgot to Vote in Uplabs ( 25 June ). Vote Here "}
        
    />
    </Box>
  </Story>
</Preview>

# Thread
Let's define a story for the `Thread preview` module

<Preview>
  <Story name="Thread preview module">
     <Box
        sx={{
          borderRadius: '6px',
          background: '#fff',
          width: '600px',
          margin: '0 auto'
        }}
        p={2}
      >
    <Thread
        link="/"
        title="What do the avatars in the topic list mean?"
        content={"After longtime I made a design for Uplabs Music player design challenge. i hope you all like this. if you like my design dont forgot to Vote in Uplabs ( 25 June ). Vote Here "}
        createdAt={"2019-11-09"}
        totalReplies={"24"}
        totalLikes={"17"}
        members={["https://files.mastodon.social/accounts/headers/001/105/637/original/6da7b224d62ebeb5.png", "https://files.mastodon.social/accounts/headers/001/105/637/original/6da7b224d62ebeb5.png", "https://files.mastodon.social/accounts/headers/001/105/637/original/6da7b224d62ebeb5.png"]}
    />
    </Box>
  </Story>
</Preview>


# Main Comment
Let's define a story for the `Main Comment preview` module

<Preview>
  <Story name="Main Comment preview module">
     <Box
        sx={{
          borderRadius: '6px',
          background: '#fff',
          width: '600px',
          margin: '0 auto'
        }}
        p={2}
      >
    <MainComment
      {...getActions()}
      content={"After longtime I made a design for Uplabs Music player design challenge. i hope you all like this. if you like my design dont forgot to Vote in Uplabs ( 25 June ). Vote Here "}      
    />
    </Box>
  </Story>
</Preview>

# Liked Comment
Let's define a story for the `Liked Comment preview` module

<Preview>
  <Story name="Liked Comment preview module">
     <Box
        sx={{
          borderRadius: '6px',
          background: '#fff',
          width: '600px',
          margin: '0 auto'
        }}
        p={2}
      >
    <LikedComment
      {...getActions()}
      actor={{icon: 'https://picsum.photos/80/80',
        link: '1',
        name: 'Ivan'}}
      createdAt='2018-11-11'
      communityName="test"
      communityLink="1"
      content={"After longtime I made a design for Uplabs Music player design challenge. i hope you all like this. if you like my design dont forgot to Vote in Uplabs ( 25 June ). Vote Here "}      
    />
    </Box>
  </Story>
</Preview> 

# Flagged Item
Let's define a story for the `Flagged Item preview` module

<Preview>
  <Story name="Flagged Item preview module">
     <Box
        sx={{
          borderRadius: '6px',
          background: '#fff',
          width: '600px',
          margin: '0 auto'
        }}
        p={2}
      >
    <FlaggedItem
        flaggedItemContext={(
        <Comment
          {...getActions()}
          url="/"
          content={
            'After longtime I made a design for Uplabs Music player design challenge. i hope you all like this. if you like my design dont forgot to Vote in Uplabs ( 25 June ). Vote Here '
          }
          isFlagged={false}
          hideActions={true}
        />)}
        ConfirmDeleteModal= {({ done }) => {
          const formik = useFormik<{}>({
          initialValues: {},
            onSubmit: () => {
              action('submit')();
              return new Promise((resolve, reject) => {
                setTimeout(resolve, 3000);
              });
            }
          });
          const getConfirmDeleteModalProps = {
            formik,
            deleteTitle: 'Delete Comment',
            deleteDescription: 'Are you sure you want to delete this comment?',
            cancel: action('cancel')
          };
          return <ConfirmDeleteModal {...getConfirmDeleteModalProps} />;
        }}
        type = "Comment"
        reason = "Abusive speech"
    />
    </Box>
  </Story>
</Preview> 